%% CALCULO de la ENERGIA - IMPLEMENTACION ROBOT
tic
%Calculo de la Potencia
tetad=[];
Torque=[];
P=[];
for i=1:n-1
syms t
phi = atan(V(2,i)/V(1,i)); % (rad) angulo entre Velocidad tangential 
%a la trayectoria y el eje X
phid=diff(phi,t);
phidd=diff(phid,t);

%Dinamica Robot :   (Vt,phi')=[DinamicaRobot]*(teta1',teta2')
%                   (At,phi")=[DinamicaRobot]*(teta1",teta2")
DinamicaRobot = [r/2 -r/2 ; -r/(2*s) -r/(2*s)];

%Cambio Base :  (Vx,Vy)=[CambioBase]*(Vt,Vn)
%               (Ax,Ay)=[CambioBase]*(At,An)
CambioBase = [cos(phi) -sin(phi) ; sin(phi) cos(phi)];

%Inercia : (F1,F2)=[Inercia]*(At,phi")
Inercia = 1/2*[m -Izz/s ; m Izz/s];

%Ruedas :   (T1,T2)=[Ruedas]*(F1,F2)
%           (V1,V2)=[Ruedas]*(teta1',teta2')
Ruedas = [r 0 ; 0 -r];

%Calculos para incontrar a el Torque y la velocidad de rotacion de las
%ruedas
Vtn = inv(CambioBase)*[V(:,i)];
tetad = [tetad inv(DinamicaRobot)*[Vtn(1);phid]];
Atn = inv(CambioBase)*[A(:,i)];
Torque = [Torque Ruedas*Inercia*[Atn(1);phidd]];
t=linspace(0,Tf(i),division); %subdivision del tiempo final en "division" partes
t=t(1:end-1);
P = [P eval(abs(Torque(1,i)*tetad(1,i))+abs(Torque(2,i)*tetad(2,i)))];
end

% Definicin inicial de la Energa
syms E(X,Vx,Ax,Y,Vy,Ay,Tf)
syms X Vx Ax [1 n-2]
syms Y Vy Ay [1 n-2]
syms Tf [1 n-1]

%% Calculo de la Energa como suma de Potencia en intervalo de tiempo
E(X,Vx,Ax,Y,Vy,Ay,Tf)=0;
%Primera parte sin el principio de la trayectoria (para evitar una falla del programa)
for i=1:n-1
    E(X,Vx,Ax,Y,Vy,Ay,Tf)=E+sum(P((i-1)*(division-1)+1:i*(division-1)))*Tf(i)/(division-1); %Calculo de la energia total consumida
end
%Ultima parte sin el final de la trayectoria (para evitar una falla del programa)
Efun = matlabFunction(E); %Trasformacin en una "Handle function" que se puede optimizar

TimeCALCULO_ENERGIA=toc;


