%% CALCULO PRIMERA SOLUCION

nvar=(n-2)*5+1; %nmero de variables
wayPoints = [x;y];  %definicin de los puntos

%Calculo de longitud de la trayectoria si las funcines de interpolacin
%son rectas.
L=0;
for i=1:(n-1)
    L=L+sqrt((x(i+1)-x(i))^2+(y(i+1)-y(i))^2);
end

%Calculo del tiempo de pasaje en cada puntos.
timePoints=[0];
for i=1:(n-1)
    timePoints=[timePoints timePoints(i)+T*sqrt((x(i+1)-x(i))^2+(y(i+1)-y(i))^2)/L];
end

%Calculo de la velocidad y acceleracin en cada puntos.
%La explicacin de como son definidas esta en un otro documento.
%Velocidad y acceleracin iniciales.
dx=dxi; dy=dyi;
ddx=ddxi; ddy=ddyi;
%-------------------------------------------------------------------------
%Creacin de una variable contenente algunos datos :
    %malfa : pendiente de direccion de llegada
    %mbeta : pendiente de direccion de partida
    %mgama : pendiente de dericcion de la velocidad
    %angleInt : ngulo entre llegada y partida
    %dirV : direcin de la velocidad, 
          %(1) -> derecha 
          %(-1) -> Izquierda
    %vel : modulo de la velocidad
    %dirA : direcin de la velocidad
          %(1) -> +90 respecto a la velocidad 
          %(-1) -> -90 respecto a la velocidad
    %acc : modulo de la acceleracin
    %timePoints : tiempo de pasaje de cada punto
data=num2cell(zeros(9,n-1));
data(:,1)={'malfa';'mbeta';'mgama';'angleInt';'versoV';'vel';'versoA';'acc';'timePoints'}; 
%-------------------------------------------------------------------------
V=L/T; %Velocidad media de la trayectoria

for i=2:(n-1)
    mbeta=(y(i+1)-y(i))/(x(i+1)-x(i)); %pendiente de direccion de llegada
    malfa=(y(i)-y(i-1))/(x(i)-x(i-1)); %pendiente de direccion de partida
    
    %Definicin de dirV y dirA a segunda de casos.
    if ((x(i+1)-x(i)>0)&&(x(i)-x(i-1))>0)||((x(i+1)-x(i)<0)&&(x(i)-x(i-1))<0)
        angleInt=pi()-(abs(atan(malfa)-atan(mbeta))); %Angulo entre llegada y partida
        mgama=(mbeta+malfa)/2; %pendiente de dericcion de la velocidad
        if x(i+1)-x(i)>0; dirV=1;        
        else dirV=-1;
        end
        if mgama>mbeta; dirA=-1;
        else dirA=1;
        end        
    else 
        angleInt=abs(atan(malfa)-atan(mbeta));  %Angulo entre llegada y partida
        mgama=-2/(mbeta+malfa); %pendiente de dericcion de la velocidad
        if (-1/mgama)>mbeta; dirA=1;
        else dirA=-1;
        end
        if ((y(i+1)-y(i)>=0)&&(y(i)-y(i-1))>=0)||((y(i+1)-y(i)<0)&&(y(i)-y(i-1))<0)
            if y(i+1)-y(i)>0; dirV=sign(mgama);        
            else dirV=-sign(mgama);
            end
        else
            if x(i+1)-x(i)>0
                if mbeta>malfa; dirV=sign(mgama); 
                else dirV=-sign(mgama);  
                end
            else
                if mbeta>malfa; dirV=-sign(mgama); 
                else dirV=sign(mgama);  
                end
            end
        end
    end
    
    vi=V*(angleInt/pi())^(1/4); %modulo de la velocidad.
    %vi=V;
    %Depiende de la velocidad media "V" y del angulo (cambio de direccin).
    
    ai=1/(abs(tan(angleInt/2)))^(1/4)*vi^2; %modulo de la acceleracin
    %Depiende del cuadrado de la velocidad "vi^2" y del angulo (cambio de direccin).
    
    %direccin de la velocidad
    dxi=cos(atan(mgama))*dirV;
    dyi=sin(atan(mgama))*dirV;
    %direccin de la accelaracin
    ddxi=-sin(atan(mgama))*1/(mgama^2+1)*dirV*dirA;
    ddyi=cos(atan(mgama))*1/(mgama^2+1)*dirV*dirA;
    %Velocidad y acceleracin finales
    dx=[dx vi*dxi];  dy=[dy vi*dyi];
    ddx=[ddx ai*ddxi];  ddy=[ddy ai*ddyi];
    %Guardar algunos datos en la variable "data"
    data{1,i}=malfa; data{2,i}=mbeta; data{3,i}=mgama;
    data{4,i}=angleInt; data{5,i}=dirV;   data{6,i}=vi;  
    data{7,i}=dirA;   data{8,i}=ai;   data{9,i}=timePoints(i);
end
%Velocidad y acceleracin finales
dx=[dx dxf];  dy=[dy dyf];
ddx=[ddx ddxf];  ddy=[ddy ddyf];
%Mostrar "data"
data; 
%EJEMPLO de Data :
%    punto de paso         2         ...        n-1
%    --------------------------------------------------
%    {'malfa'     }    {[     1]}    ...    {[      3]}
%    {'mbeta'     }    {[     3]}    ...    {[      1]}
%    {'mgama'     }    {[     2]}    ...    {[      2]}
%    {'angleInt'  }    {[2.6779]}    ...    {[ 2.6779]}
%    {'versoV'    }    {[     1]}    ...    {[      1]}
%    {'vel'       }    {[0.4859]}    ...    {[ 0.4859]}
%    {'versoA'    }    {[     1]}    ...    {[     -1]}
%    {'acc'       }    {[0.0557]}    ...    {[ 0.0557]}
%    {'timePoints'}    {[2.4807]}    ...    {[22.5193]}

%Lo unico que necesitamos son [dx,dy] y [ddx,ddy], que tienen todos los
%valores de velocidad y aceleracin de la solucin inicial.

%Cancelar todas las variables que servan al calculo de [dx,dy] y [ddx,ddy]
clear ai vi; %cancelar los modulos de la velocidad y aceleracin
clear dxi dxf dyi dyf ddxi ddxf ddyi ddyf; %cancelar las dirrecciones de la velocidad y aceleracin
clear mbeta malfa mgama; %cancelar los valores de las pendientes que sirven al calcolo 
clear dirA dirV; %cancelar el sentido de la velocidad y aceleracin 
