%% CALCULO de los vectores velocidad (V) y aceleracin (A)
tic
%Definicin de las variables
syms X Vx Ax [1 n-2]
syms Y Vy Ay [1 n-2]
syms Tf [1 n-1]
%Definicin de los parametros de las ecuaciones
syms p3 p4 p5
%Definicin de los vectores Deplazamiento, Velocidad y Aceleracin
S=[]; V=[]; A=[];

%------------------------------------------------------------------------------------------------------------
%Trayectoria entre los dos primeros puntos de paso
i=1;
%CALCULO EXPLICADO SOLAMENTE PARA ESTA PRIMERA TRAYECTORIA, LUEGO ES LO
%MISMO POR LAS OTRAS PARTE DE TRAYECTORIA.
%Calculo de P(t) = p0x + p1x*t + p2x*t^2 + p3x*t^3 + p4x*t^4 + p5x*t^5
% p0x=x(1) p1x=dx(1) p2x=ddx(3)
%eqn1 : Px(Tf(i))=X(i)
%eqn2 : Px'(Tf(i))=Vx(i)
%eqn3 : Px"(Tf(i))=Ax(i)
eqn1 = x(i)+dx(i)*Tf(i)+ddx(i)*Tf(i)^2+p3*Tf(i)^3+p4*Tf(i)^4+p5*Tf(i)^5 == X(i); 
eqn2 = dx(i)+2*ddx(i)*Tf(i)+3*p3*Tf(i)^2+4*p4*Tf(i)^3+5*p5*Tf(i)^4 == Vx(i); 
eqn3 = 2*ddx(i)+6*p3*Tf(i)+12*p4*Tf(i)^2+20*p5*Tf(i)^3 == Ax(i); 
%Poner el sistema como una matrix : Matrix*X=B donde X=[p3 p4 p5]
[Matrix,B] = equationsToMatrix([eqn1, eqn2, eqn3], [p3, p4, p5]);
SolveSys = linsolve(Matrix,B); 
p3x=SolveSys(1);
p4x=SolveSys(2);
p5x=SolveSys(3);

%Calculo de P(t) segundo y (lo mismo que para x con otras variables)
eqn1 = y(i)+dy(i)*Tf(i)+ddy(i)*Tf(i)^2+p3*Tf(i)^3+p4*Tf(i)^4+p5*Tf(i)^5 == Y(i);
eqn2 = dy(i)+2*ddy(i)*Tf(i)+3*p3*Tf(i)^2+4*p4*Tf(i)^3+5*p5*Tf(i)^4 == Vy(i);
eqn3 = 2*ddy(i)+6*p3*Tf(i)+12*p4*Tf(i)^2+20*p5*Tf(i)^3 == Ay(i);
[Matrix,B] = equationsToMatrix([eqn1, eqn2, eqn3], [p3, p4, p5]);
SolveSys = linsolve(Matrix,B);
p3y=SolveSys(1);
p4y=SolveSys(2);
p5y=SolveSys(3);

%Calculo de S,V y A en algunos puntos de la trayectoria. Cada Tf/division
%unidades de tiempo
%t=linspace(0,Tf(i),division); %subdivision del tiempo final en "division" partes
syms t
%S = [S [x(i)+dx(i)*t+ddx(i)*t.^2+p3x*t.^3+p4x*t.^4+p5x*t.^5 ; y(i)+dy(i)*t+ddy(i)*t.^2+p3y*t.^3+p4y*t.^4+p5y*t.^5]];
V = [V [dx(i)+2*ddx(i)*t+3*p3x*t.^2+4*p4x*t.^3+5*p5x*t.^4 ; dy(i)+2*ddy(i)*t+3*p3y*t.^2+4*p4y*t.^3+5*p5y*t.^4]];
A = [A [2*ddx(i)+6*p3x*t+12*p4x*t.^2+20*p5x*t.^3 ; 2*ddy(i)+6*p3y*t+12*p4y*t.^2+20*p5y*t.^3]];

%------------------------------------------------------------------------------------------------------------
%Trayectoria entre el segundo y el penltimopunto de paso
for i=2:n-2
%Calculo de P(t) segundo x
eqn1 = X(i-1)+Vx(i-1)*Tf(i)+Ax(i-1)*Tf(i)^2+p3*Tf(i)^3+p4*Tf(i)^4+p5*Tf(i)^5 == X(i);
eqn2 = Vx(i-1)+2*Ax(i-1)*Tf(i)+3*p3*Tf(i)^2+4*p4*Tf(i)^3+5*p5*Tf(i)^4 == Vx(i);
eqn3 = 2*Ax(i-1)+6*p3*Tf(i)+12*p4*Tf(i)^2+20*p5*Tf(i)^3 == Ax(i);
[Matrix,B] = equationsToMatrix([eqn1, eqn2, eqn3], [p3, p4, p5]);
SolveSys = linsolve(Matrix,B);
p3x=SolveSys(1);
p4x=SolveSys(2);
p5x=SolveSys(3);

%Calculo de P(t) segundo y
eqn1 = Y(i-1)+Vy(i-1)*Tf(i)+Ay(i-1)*Tf(i)^2+p3*Tf(i)^3+p4*Tf(i)^4+p5*Tf(i)^5 == Y(i);
eqn2 = Vy(i-1)+2*Ay(i-1)*Tf(i)+3*p3*Tf(i)^2+4*p4*Tf(i)^3+5*p5*Tf(i)^4 == Vy(i);
eqn3 = 2*Ay(i-1)+6*p3*Tf(i)+12*p4*Tf(i)^2+20*p5*Tf(i)^3 == Ay(i);
[Matrix,B] = equationsToMatrix([eqn1, eqn2, eqn3], [p3, p4, p5]);
SolveSys = linsolve(Matrix,B);
p3y=SolveSys(1);
p4y=SolveSys(2);
p5y=SolveSys(3);

%Calculo de S,V y A en algunos puntos de la trayectoria. Cada Tf/division
%unidades de tiempo
%t=linspace(0,Tf(i),division); %subdivision del tiempo final en "division" partes
syms t
%S = [S [X(i-1)+Vx(i-1)*t+Ax(i-1)*t.^2+p3x*t.^3+p4x*t.^4+p5x*t.^5 ; Y(i-1)+Vy(i-1)*t+Ay(i-1)*t.^2+p3y*t.^3+p4y*t.^4+p5y*t.^5]];
V = [V [Vx(i-1)+2*Ax(i-1)*t+3*p3x*t.^2+4*p4x*t.^3+5*p5x*t.^4 ; Vy(i-1)+2*Ay(i-1)*t+3*p3y*t.^2+4*p4y*t.^3+5*p5y*t.^4]];
A = [A [2*Ax(i-1)+6*p3x*t+12*p4x*t.^2+20*p5x*t.^3 ; 2*Ay(i-1)+6*p3y*t+12*p4y*t.^2+20*p5y*t.^3]];

end

%------------------------------------------------------------------------------------------------------------
%Trayectoria entre los dos ltimos puntos de paso
i=n-1;
%Calculo de P(t) segundo x
eqn1 = X(i-1)+Vx(i-1)*Tf(i)+Ax(i-1)*Tf(i)^2+p3*Tf(i)^3+p4*Tf(i)^4+p5*Tf(i)^5 == x(n);
eqn2 = Vx(i-1)+2*Ax(i-1)*Tf(i)+3*p3*Tf(i)^2+4*p4*Tf(i)^3+5*p5*Tf(i)^4 == dx(n);
eqn3 = 2*Ax(i-1)+6*p3*Tf(i)+12*p4*Tf(i)^2+20*p5*Tf(i)^3 == ddx(n);
[Matrix,B] = equationsToMatrix([eqn1, eqn2, eqn3], [p3, p4, p5]);
SolveSys = linsolve(Matrix,B);
p3x=SolveSys(1);
p4x=SolveSys(2);
p5x=SolveSys(3);

%Calculo de P(t) segundo y
eqn1 = Y(i-1)+Vy(i-1)*Tf(i)+Ay(i-1)*Tf(i)^2+p3*Tf(i)^3+p4*Tf(i)^4+p5*Tf(i)^5 == y(n);
eqn2 = Vy(i-1)+2*Ay(i-1)*Tf(i)+3*p3*Tf(i)^2+4*p4*Tf(i)^3+5*p5*Tf(i)^4 == dy(n);
eqn3 = 2*Ay(i-1)+6*p3*Tf(i)+12*p4*Tf(i)^2+20*p5*Tf(i)^3 == ddy(n);
[Matrix,B] = equationsToMatrix([eqn1, eqn2, eqn3], [p3, p4, p5]);
SolveSys = linsolve(Matrix,B);
p3y=SolveSys(1);
p4y=SolveSys(2);
p5y=SolveSys(3);

%Calculo de S,V y A en algunos puntos de la trayectoria. Cada Tf/division
%unidades de tiempo
%t=linspace(0,Tf(i),division); %subdivision del tiempo final en "division" partes
syms t
%S = [S [X(i-1)+Vx(i-1)*t+Ax(i-1)*t.^2+p3x*t.^3+p4x*t.^4+p5x*t.^5 ; Y(i-1)+Vy(i-1)*t+Ay(i-1)*t.^2+p3y*t.^3+p4y*t.^4+p5y*t.^5]];
V = [V [Vx(i-1)+2*Ax(i-1)*t+3*p3x*t.^2+4*p4x*t.^3+5*p5x*t.^4 ; Vy(i-1)+2*Ay(i-1)*t+3*p3y*t.^2+4*p4y*t.^3+5*p5y*t.^4]];
A = [A [2*Ax(i-1)+6*p3x*t+12*p4x*t.^2+20*p5x*t.^3 ; 2*Ay(i-1)+6*p3y*t+12*p4y*t.^2+20*p5y*t.^3]];

%Cancelar las variables que servian solo para el calculo
clear eqn1 eqn2 eqn3 Matrix B SolveSys;
clear p3y p4y p5y p3x p4x p5x p3 p4 p5;

TimeCALCULO_VyA=toc;
