%% MINIMIZATION
tic
%Crear una solucin inicial con los resultados de INITIAL_GUESS
%sol_Inicial = [velocidad_x  aceleracion_x  velocidad_y  aceleracion_y  tiempo_de_paso]
sol_Inicial = [dx(2:n-1) ddx(2:n-1) dy(2:n-1) ddy(2:n-1) timePoints(2:n)-timePoints(1:n-1)];
sol_Final = sol_Inicial;
%%

%Crear las condiciones para las variables (Max y min)
% lb : lmite inferior
% ub : lmite superior
% lb < x < ub
% b : maximo tiempo
% A : vectores de 0 y 1. 1 para las variables del tiempo y 0 para las otras
% A*x < b
Tfmax=T; Tfmin=0; %limite en el tiempo
lb=zeros(1,nvar); ub=zeros(1,nvar); %vectores lb y ub inicialmente llenos de cero
if OptionTime=="Tmax"; b=[T ; 0]; %Opcion Tmax
else b=[T*1.1 ; -T*0.1]; %Opcion Taprox
end
Amatrix=zeros(2,nvar); %Matriz para calculo tiempo
for i=1:n-2
    ub(i)=Vmax; ub(i+2*(n-2))=Vmax; %lmite de Velocidad superior
    ub(i+(n-2))=Amax; ub(i+3*(n-2))=Amax; %lmite de Aceleracin superior
    ub(i+4*(n-2))=Tfmax; %lmite de tiempo superior
    lb(i)=Vmin; lb(i+2*(n-2))=Vmin; %lmite de Velocidad inferior
    lb(i+(n-2))=Amin; lb(i+3*(n-2))=Amin; %lmite de Aceleracin inferior
    lb(i+4*(n-2))=Tfmin; %lmite de tiempo inferior
    Amatrix(1,i+4*(n-2))=1;
    Amatrix(2,i+4*(n-2))=-1;
end
lb(nvar)=Tfmin; %lmite de tiempo inferior
ub(nvar)=Tfmax; %lmite de tiempo superior
Amatrix(1,nvar)=1;
Amatrix(2,nvar)=-1;
%Substituire variables de la funcin de Efun para obtener Efun(X,Y,var) 
%con "(X,Y)" la posicin de cada puntos y "var" el vector de parametros
% var = [velocidad_x aceleracion_x velocidad_y aceleracion_y tiempo_de_paso]
Echar = char(Efun); %convertir Efun de handle_function-->char
Estr = string(Echar); %convertir Efun de char-->string
%Todas las substitucines :
Estr = replace(Estr,string(Echar(1:32+(n-3)*26)),"@(X,Y,var)");
for i=1:n-2
    Estr = replace(Estr,string(char(X(i))),"X("+i+")");
    Estr = replace(Estr,string(char(Vx(i))),"var("+i+")");
    Estr = replace(Estr,string(char(Ax(i))),"var("+(i+(n-2))+")");
    Estr = replace(Estr,string(char(Y(i))),"Y("+i+")");
    Estr = replace(Estr,string(char(Vy(i))),"var("+(i+2*(n-2))+")");
    Estr = replace(Estr,string(char(Ay(i))),"var("+(i+3*(n-2))+")");
    Estr = replace(Estr,string(char(Tf(i))),"var("+(i+4*(n-2))+")");
end
Estr = replace(Estr,string(char(Tf(n-1))),"var("+(1+5*(n-2))+")");
Evar = str2func(Estr); %convertir Efun de string-->function_handle
Xvar=x(2:n-1); Yvar=y(2:n-1); %definir X  y Y como punto de paso definido en INPUT
%No se he hizo antes para permitir la modificacin de dichos puntos.
%%
%Minimization
% Amatrix,b,lb,ub limitacion con efectos :    A*x < b   ,   lb < x < ub
Aeq=[]; beq=[]; %limitacin sin efectos
nonlcon=[];
option=optimoptions(@fmincon,'MaxIterations',100*nvar,'MaxFunctionEvaluations',100*nvar*nvar)
[solnew,fval]=fmincon(@(var) Evar(Xvar,Yvar,var),sol_Final,Amatrix,b,Aeq,beq,lb,ub,nonlcon,option)
sol_Final=solnew; %substitucinde la solucin inicial con la final

%Cancelar las variables que servian solo para esta seccin
clear Estr Echar; 
TimeMINIMIZACION=toc;

%% Guardar datos
%INPUT :        n division Tmax/Taprox
%Sol initial :  X velocidadX AceleracionX Y velocidadY AceleracionY Tf T
%Sol final:     X velocidadX AceleracionX Y velocidadY AceleracionY Tf T

s1.n = n;
s1.division = division;
s1.OptionTime = OptionTime;
s1.wayPoints = wayPoints;
s1.V_inicial = [dx(1) dy(1)];
s1.V_final = [dx(n) dy(n)];
s1.A_inicial = [ddx(1) ddy(1)];
s1.A_final = [ddx(n) ddy(n)];
s1.Robot.m = m;
s1.Robot.Izz = Izz;
s1.Robot.r = r;
s1.Robot.s = s;
s1.Opti.Vmax = Vmax;
s1.Opti.Vmin = Vmin;
s1.Opti.Amax = Amax;
s1.Opti.Amin = Amin;
s1.sol_Inicial = sol_Inicial;
s1.sol_Final = sol_Final;
s1.RunningTime.TimeCALCULO_VyA = TimeCALCULO_VyA;
s1.RunningTime.TimeCALCULO_ENERGIA = TimeCALCULO_ENERGIA;
s1.RunningTime.TimeMINIMIZACION = TimeMINIMIZACION;

NameTest=Name;
for i=1:10
    if exist([NameTest '.mat'])==2; 
        NameTest=[Name '_' num2str(i)]
    else
        save([NameTest '.mat'],'-struct','s1')
        break;
    end
end
