%%  OUTPUT
close all; clc;
%%
%leer los output
%load('.mat')
nvar=5*(n-2)+1;
x = wayPoints(1,:);
y = wayPoints(2,:);
dx=zeros(1,n); dy=zeros(1,n); ddx=zeros(1,n); ddy=zeros(1,n);
dx(1) = V_inicial(1);
dy(1) = V_inicial(2);
dx(n) = V_final(1);
dy(n) = V_final(2);
ddx(1) = A_inicial(1);
ddy(1) = A_inicial(2);
ddx(n) = A_final(1);
ddy(n) = A_final(2);
m = Robot.m;
Izz = Robot.Izz;
r = Robot.r;
s = Robot.s;
Vmax = Opti.Vmax;
Vmin = Opti.Vmin;
Amax = Opti.Amax;
Amin = Opti.Amin;

%% CALCULAR las TRAYECTORIAS inicial y final con [q,qd,qdd,pp] = quinticpolytraj(...)
sample=0.1; %Definicin de la precisin de la trayectoria

%Poner como solucin la solucin inicial y calcular la trayectoria inicial-----------
timePointsi=zeros(1,n);
for i=2:n-1
    dx(i)=sol_Inicial(i-1); %velocidad segundo x
    ddx(i)=sol_Inicial(i+n-3); %aceleracion segundo x
    dy(i)=sol_Inicial(i+2*n-5); %velocidad segundo y
    ddy(i)=sol_Inicial(i+3*n-7); %aceleracion segundo y
    timePointsi(i)=timePointsi(i-1)+sol_Inicial(i+4*n-9); %tiempo de paso
end
timePointsi(n)=timePointsi(n-1)+sol_Inicial(5*n-9); %tiempo de paso
tSamplesi=0:sample:timePointsi(n); %division del tiempo para calcular la trayectoria
%Uso de la funcin de interpolacin : entre cada puntos crea una funcin polinomial de quinto grado
[qi,qdi,qddi,ppi] = quinticpolytraj(wayPoints,timePointsi,tSamplesi,'VelocityBoundaryCondition',[dx; dy],'AccelerationBoundaryCondition',[ddx; ddy]);

%Poner como solucin la solucin final y calcular la trayectoria optimizada-----------
timePoints=zeros(1,n);
for i=2:n-1
    dx(i)=sol_Final(i-1); %velocidad segundo x
    ddx(i)=sol_Final(i+n-3); %aceleracion segundo x
    dy(i)=sol_Final(i+2*n-5); %velocidad segundo y
    ddy(i)=sol_Final(i+3*n-7);  %aceleracion segundo y
    timePoints(i)=timePoints(i-1)+sol_Final(i+4*n-9); %tiempo de paso
end    
timePoints(n)=timePoints(n-1)+sol_Final(5*n-9); %tiempo de paso
tSamples=0:sample:timePoints(n); %division del tiempo para calcular la trayectoria
%Uso de la funcin de interpolacin.
%Entre cada puntos crea una funcin polinomial de quinto grado
[q,qd,qdd,pp] = quinticpolytraj(wayPoints,timePoints,tSamples,'VelocityBoundaryCondition',[dx; dy],'AccelerationBoundaryCondition',[ddx; ddy]);

%% CALCULAR PAR
%Inicial
phi = atan(qdi(2,:)./qdi(1,:)); %+sign(qdi(2,:)).*(1-sign(qdi(1,:)))*pi()/2; %phi=atan(Vy/Vx) (rad) angulo entre Velocidad tangential 
%a la trayectoria y eje X

for j=1:1:1000
    for i=2:length(phi)
        if phi(i)-phi(i-1)>2.9
            phi(i)=phi(i)-pi();
        end
        if phi(i)-phi(i-1)<-2.9
          phi(i)=phi(i)+pi();
        end
     if phi(i)-phi(i-1)>1.3
            phi(i)=phi(i)-pi()/2;
     end
        if phi(i)-phi(i-1)<-1.3
            phi(i)=phi(i)+pi()/2;
        end
    end
end
phid=diff(phi)/sample;
phidd=diff(phid)/sample;

%Dinamica Robot :   (Vt,phi')=[DinamicaRobot]*(teta1',teta2')
%                   (At,phi")=[DinamicaRobot]*(teta1",teta2")
DinamicaRobot = [r/2 -r/2 ; -r/(2*s) -r/(2*s)];

%Inercia : (F1,F2)=[DinamicaRobot]*(At,phi")
Inercia = 1/2*[m -Izz/s ; m Izz/s];

%Ruedas :   (T1,T2)=[Ruedas]*(F1,F2)
%           (V1,V2)=[Ruedas]*(teta1',teta2')
Ruedas = [r 0 ; 0 -r];
tetadi=[];
Torquei=[];
Pi=[];
for i=1:1:length(phidd)
%Cambio Base :  (Vx,Vy)=[CambioBase]*(Vt,Vn)
%               (Ax,Ay)=[CambioBase]*(At,An)
CambioBase = [cos(phi(i)) -sin(phi(i)) ; sin(phi(i)) cos(phi(i))];
Vtn = inv(CambioBase)*[qdi(:,i)];
tetadi = [tetadi inv(DinamicaRobot)*[Vtn(1);phid(i)]];
Atn = inv(CambioBase)*[qddi(:,i)];
Torquei = [Torquei Ruedas*Inercia*[Atn(1);phidd(i)]];
Pi = [Pi abs(Torquei(1,i)*tetadi(1,i))+abs(Torquei(2,i)*tetadi(2,i))];
end

%Final
phi = atan(qd(2,:)./qd(1,:)); %+sign(qd(2,:)).*(1-sign(qd(1,:)))*pi()/2; %phi=atan(Vy/Vx) (rad) angulo entre Velocidad tangential 
%a la trayectoria y eje X
for j=1:1:1000
    for i=2:length(phi)
        if phi(i)-phi(i-1)>2.9
            phi(i)=phi(i)-pi();
        end
        if phi(i)-phi(i-1)<-2.9
          phi(i)=phi(i)+pi();
        end
     if phi(i)-phi(i-1)>1.3
            phi(i)=phi(i)-pi()/2;
     end
        if phi(i)-phi(i-1)<-1.3
            phi(i)=phi(i)+pi()/2;
        end
    end
end
phid=diff(phi)/sample;
phidd=diff(phid)/sample;


%Dinamica Robot :   (Vt,phi')=[DinamicaRobot]*(teta1',teta2')
%                   (At,phi")=[DinamicaRobot]*(teta1",teta2")
DinamicaRobot = [r/2 -r/2 ; -r/(2*s) -r/(2*s)];

%Inercia : (F1,F2)=[DinamicaRobot]*(At,phi")
Inercia = 1/2*[m -Izz/s ; m Izz/s];

%Ruedas :   (T1,T2)=[Ruedas]*(F1,F2)
%           (V1,V2)=[Ruedas]*(teta1',teta2')
Ruedas = [r 0 ; 0 -r];

%Calculos para incontrar a el Torque y la velocidad de rotacion de las
%ruedas
tetad=[];
Torque=[];
Pf=[];
for i=1:1:length(phidd)
%Cambio Base :  (Vx,Vy)=[CambioBase]*(Vt,Vn)
%               (Ax,Ay)=[CambioBase]*(At,An)
CambioBase = [cos(phi(i)) -sin(phi(i)) ; sin(phi(i)) cos(phi(i))];
Vtn = inv(CambioBase)*[qd(:,i)];
tetad = [tetad inv(DinamicaRobot)*[Vtn(1);phid(i)]];
Atn = inv(CambioBase)*[qdd(:,i)];
Torque = [Torque Ruedas*Inercia*[Atn(1);phidd(i)]];
Pf = [Pf abs(Torque(1,i)*tetad(1,i))+abs(Torque(2,i)*tetad(2,i))];
end

%Calculo Energia
Ei=sum(Pi(1:end-1))*sample; %Inicial
Ef=sum(Pf(1:end-1))*sample; %Final

%% TRAZAR TRAYECTORIA
%   los punto de paso la trayectoria Optimizada,
%   la aceleracion y la velocidad en algunos puntos de la trayectoria
%   el modulo de la aceleracion y velocidad (inicial y optimizada)

%Punto de paso y Trayectoria inicial y optimizada
figure();
hold on
plot(wayPoints(1,:),wayPoints(2,:),'o','LineWidth',2); %puntos de paso
fnplt(pp,'-',1); %trayectoria optimizada
fnplt(ppi, '--b', 1); %trayectoria inicial

for i=1:n
    plot([x(i) x(i)+dx(i)],[y(i) y(i)+dy(i)],'r');
    plot([x(i) x(i)+ddx(i)],[y(i) y(i)+ddy(i)],'g');
end

legend('points','Optimal trajectory','Initial Trajectory','1th derivate','2th derivate','FontSize',10);
title('Trayectoria');
xlabel('X');
ylabel('Y');
%Mostrar el tiempo de pasaje en cada puntos
text(wayPoints(1,:)+0.2,wayPoints(2,:)+0.2,num2cell(timePoints),'FontSize',10); 
grid on
axis equal

%% VELOCIDAD y ACELERACION
figure()
hold on
%SOLUCION INICIAL - Modulo velocidad y aceleracion
Vabs=sqrt(qdi(1,:).^2+qdi(2,:).^2); %modulo di velocidad en todos los puntos
Aabs=sqrt(qddi(1,:).^2+qddi(2,:).^2); %modulo di acceleracin en todos los puntos
plot(tSamplesi,Vabs(1,:),'--');   %Mostrar modulo di velocidad en todos los puntos
plot(tSamplesi,Aabs(1,:),'--');   %Mostrar modulo di acceleracin en todos los puntos
%SOLUCION OPTIMIZADA - Modulo velocidad y aceleracion
Vabs=sqrt(qd(1,:).^2+qd(2,:).^2); %modulo di velocidad en todos los puntos
Aabs=sqrt(qdd(1,:).^2+qdd(2,:).^2); %modulo di acceleracin en todos los puntos
plot(tSamples,Vabs(1,:),'LineWidth',1);   %Mostrar modulo di velocidad en todos los puntos
plot(tSamples,Aabs(1,:),'LineWidth',1);   %Mostrar modulo di acceleracin en todos los puntos
%SOLUCION OPTIMIZADA - lineas verticales en cada tiempo de paso
for i=1:n-1
    xline(timePoints(i),'--','LineWidth',1);
end
xlabel('time');
ylabel('Vel y Acc');
title('Dynamic profil');
legend('Velocidad Inicial','Acceleracin Inicial','Velocidad Opt.','Acceleracin Opt.','FontSize',10);
grid on


%% TRAZAS PAR
figure()
hold on
plot(tSamples(1:length(phidd)),Torque(1,(1:end)));   %Mostrar tetad inicial de la rueda 1 en todos los puntos
plot(tSamples(1:length(phidd)),Torque(2,(1:end)));
%SOLUCION OPTIMIZADA - lineas verticales en cada tiempo de paso inicial
for i=1:n
    xline(timePoints(i),'--','LineWidth',1);
end
title('Torque')
xlabel('time');
ylabel('Torque (N*m)');
grid on

%% TRAZAR TETAD
figure()
hold on
plot(tSamples(1:length(phidd)),tetad(1,(1:end)));   %Mostrar tetad inicial de la rueda 1 en todos los puntos
plot(tSamples(1:length(phidd)),tetad(2,(1:end)));
%SOLUCION OPTIMIZADA - lineas verticales en cada tiempo de paso inicial
for i=1:n
    xline(timePoints(i),'--','LineWidth',1);
end
title('tetad')
xlabel('time');
ylabel('tetad (rad/s)');
grid on
%% TRAZAR POTENCIA :
%Mostrar la evolucin de la potencia en el tiempo
figure()
hold on
%plot(tSamplesi,Pi,'--');
plot(tSamples(1:length(phidd)),Pf(1:end),'LineWidth',1);
%Mostrar el tiempo de paso
for i=1:n
    xline(timePoints(i),'--','LineWidth',1);
end
title('Potencia');
xlabel('tiempo (s)');
ylabel('Potencia (W)');
grid on

%% TRAZAR ROTACION PHI :
figure()
hold on
grid on
plot(tSamples,phi*360/2/pi());
title('phi')
xlabel('tiempo')
ylabel('phi ()')

%% Variacion de las variables y Parametros
varNames =string.empty(nvar+2,0);
for i=1:n-2
    varNames(i) = "P"+(i+1)+" Vx (m/s)";
    varNames(i+(n-2)) = "P"+(i+1)+" Ax (m/s^2)";
    varNames(i+2*(n-2)) = "P"+(i+1)+" Vy (m/s)";
    varNames(i+3*(n-2)) = "P"+(i+1)+" Ay (m/s^2)";
    varNames(i+4*(n-2)) = "T (s) da P"+(i)+" a P"+(i+1);
end
varNames(nvar) = "T (s) da P"+(n-1)+" a P"+(n);
varNames(nvar+1) = "T total (s)";
varNames(nvar+2) = "Energia (J)";
varTypes = repmat("double",[1 nvar+2]);
rowNames = {'variables inicial';'variables final';'diferencia en %'};
size = [3 nvar+2];
Variables = table('Size',size,'VariableTypes',varTypes,'VariableNames',varNames,'RowNames',rowNames);
LineOne = [sol_Inicial sum(sol_Inicial(nvar-n+1:nvar)) Ei];
LineTwo = [sol_Final sum(sol_Final(nvar-n+1:nvar)) Ef];
LineThree = (LineTwo-LineOne)./LineOne*100;
Variables(1,:)=num2cell(LineOne);
Variables(2,:)=num2cell(LineTwo);
Variables(3,:)=num2cell(LineThree);
Variables

